<?php
require_once('./Client/Client.php');
class UserController
{
    function __construct()
    {
        try {
            global $dsn, $rep, $vues, $error;
            $action = $_REQUEST['action'];
            echo $action;
            switch ($action) {
                case NULL:
                    $this->goToHome();
                    break;
                case "goToHome":
                    $this->goToHome();
                    break;
                case "goToPresentation":
                    $this->goToPresentation();
                    break;
                case "goToEnigme":
                    $this->goToEnigme();
                    break;
                case "goToTest":
                    $this->goToTest();
                    break;
                case "goToNext":
                    $this->goToNext();
                    break;
                case "goToQueue":
                    $this->goToQueue();
                    break;
                case "logout":
                    $this->logout();
                    break;
                case "launchGame":
                    $this->launchGame();
                    break;
                default:
                    $error = "Action non valide";
                    require($rep . $vues['erreur']);
                    break;
            }
        } catch (PDOException $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        } catch (Exception $e2) {
            $error = $e2->getMessage();
            require($rep . $vues['erreur']);
        }
    }
    public function goToHome()
    {
        try {
            global $rep, $vues;
            require($rep . $vues['main']);
        } catch (Exception $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        }
    }
    public function goToPresentation()
    {
        try {
            global $rep, $vues;
            require($rep . $vues['presentation']);
        } catch (Exception $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        }
    }
    public function goToTest()
    {
        try {
            global $rep, $vues;
            require($rep . $vues['test']);
        } catch (Exception $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        }
    }
    public function goToEnigme()
    {
        try {
            global $rep, $vues;
            $model = new UserModel();
            $ordre = $_REQUEST['ordre'];
            $enigme = $model->getEnigmeByOrdre($ordre);
            if ($enigme->getNom() == "") {
                header("Location: index.php?action=goToHome");
            }
            require($rep . $vues['enigmePage']);
        } catch (Exception $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        }
    }
    public function goToNext()
    {
        try {
            global $rep, $vues, $error;
            $nettoyage = new Nettoyage();
            $num = $nettoyage->cleanInt($_REQUEST['num']);
            require($rep . $vues['next'] . $num . ".html");
        } catch (Exception $e) {
            $error = "Erreur Inconnue";
            require($rep . $vues['erreur']);
        }
    }
    public function goToQueue()
    {
        try {
            global $rep, $vues, $error; //$serverAdress,$port;
            require($rep . $vues['queue']);
            $model = new UserModel();
            $model->addToQueue();
            $client = Client::getInstance();
            $client->Queuing();
            header('Location: index.php?action=launchGame');
        } catch (Exception $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        }
    }
    public function launchGame(){
        try {
            global $rep, $vues, $error;
            $model = new UserModel();
            $model->launchGame();
            require($rep . $vues['partie']);
        }
        catch (Exception $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        }
    }
    public function logout()
    {
        $_SESSION['role'] = 'visitor';
        header('Location: index.php');
    }
}